'''
Created on Mar 28, 2014

@author: k.edeline
'''

def levenshtein(s1, s2, lower=True):
    """
    levenshtein distance for int arrays
    0 are jokers, they are always compared equals if lower is True 
                always different if lower is False
    """
    if len(s1) < len(s2):
        return levenshtein(s2, s1)
    if len(s2) == 0:
        return len(s1)
 
    previous_row = xrange(len(s2) + 1)
    for i, c1 in enumerate(s1):
        current_row = [i + 1]
        for j, c2 in enumerate(s2):
            insertions = previous_row[j + 1] + 1 # j+1 instead of j since previous_row and current_row are one character longer
            deletions = current_row[j] + 1       # than s2
            substitutions = previous_row[j] + ((c1 != c2) if lower else (c1 != c2 and c1!=0 and c2!=0 ))
            current_row.append(min(insertions, deletions, substitutions))
        previous_row = current_row
 
    return previous_row[-1]     
    
        
