#!/usr/bin/env python
"""
Created on Sep 14, 2015

@author: K.Edeline
""" 

from Plotbox import Plotbox
from Parsebox import Parsebox

def example():
    """
    Examples for sample dataset.
    """

    # First, parse the dataset
    pb = Parsebox()
    pb.parse(substr4="opt5.4",substr6="opt5.6")

    # Uncomment the following line to print all parsed data.
    # print pb

    # Print the amount of parsed probes per source addresses
    src4,src6=pb.get_src_stats()
    for k,d in src4.iteritems():
        print str(d)+" IPv4 probes from "+k+" parsed."
    for k,d in src6.iteritems():
        print str(d)+" IPv6 probes from "+k+" parsed."
    print 


    # Instantiate the plotting module
    plotbox=Plotbox(pb,"plot/")

    # Scamper output status
    print "="*50
    print "Scamper state statistics and plots."
    print "="*50 
    plotbox.success_rate()

    # AS-path related functions
    print "="*50
    print "Number of AS hops statistics and plots."
    print "="*50
    plotbox.as_path_len_cmp()

    print "="*50
    print "v4/v6 AS paths comparisons statistics and plots."
    print "="*50
    plotbox.as_path_cmp()

    # Path lengths comparisons
    print "="*50
    print "v4/v6 Path length comparisons statistics and plots."
    print "="*50 
    plotbox.path_cdf_cmp()

    print "="*50
    print "Path lengths statistics and plots."
    print "="*50 
    plotbox.path_cdf()
   
    # Middlebox modifications
    print "="*50
    print "Middleboxes modifications."
    print "="*50
    plotbox.middleboxes_modif_categories()
    print "="*50
    print "Middleboxes modifications plots."
    print "="*50
    plotbox.middleboxes_overall()
    print "="*50
    print "Middleboxes modifications 3D plots."
    print "="*50
    plotbox.middleboxes_continent()
    
    # ICMP 'original datagram' size
    print "="*50
    print "ICMP sizes stats"
    print "="*50
    plotbox.icmp_size_stats()
    print "="*50
    print "ICMP sizes Plots"
    print "="*50
    plotbox.icmp_size_plots()

    
if __name__ == "__main__":
    example()   
    
